
        .MODEL  Small
        .386
        .STACK  1024
        OPTION  CaseMap:None

;####################################################################################

        .DATA

PosBuf  db '00000 00000',0Dh,0Ah,24h

;************************************************************************************

        .DATA?

PosX    dw ?
PosY    dw ?

;####################################################################################

        .CODE

;************************************************************************************

B2Asc   PROC

        mov     bx,10
        mov     cx,5

B2Asc0: xor     dx,dx
        div     bx
        or      dl,30h
        mov     [di],dl
        dec     di
        loop    B2Asc0

        ret

B2Asc   ENDP

;************************************************************************************

_main   PROC

;----------------------------------

;DS = DGROUP

        mov     ax,@data
        mov     ds,ax
        jmp short Empty1

;----------------------------------

;empty the keyboard buffer

Empty0: mov     ah,0
        int     16h

Empty1: mov     ah,1
        int     16h
        jnz     Empty0

;----------------------------------

;initialize the mouse driver

        xor     ax,ax
        int     33h
        mov     di,offset PosBuf+10
        call    B2Asc
        inc     di
        mov     ah,9
        mov     dx,di
        int     21h

;----------------------------------

;first read of mouse status

        mov     ax,3
        int     33h
        jmp short UpdDisp

;----------------------------------

;mouse position loop

TopOfLoop:
        cmp     cx,PosX
        jnz     UpdDisp

        cmp     dx,PosY
        jz      NextPass

UpdDisp:
        mov     PosY,dx
        mov     PosX,cx
        xchg    ax,dx
        push    cx
        mov     di,offset PosBuf+10
        call    B2Asc
        pop     ax
        dec     di
        call    B2Asc
        inc     di
        mov     ah,9
        mov     dx,di
        int     21h

NextPass:
        mov     ah,1
        int     16h
        jz      RdMouse

        mov     ah,0
        int     16h
        jmp short ProgExit

RdMouse:
        mov     ax,3
        int     33h
        shr     bx,1
        jnc     TopOfLoop

        mov     ax,cx
        or      ax,dx
        shr     ax,3
        jnz     TopOfLoop

;----------------------------------

;terminate

ProgExit:
        mov     ax,4C00h
        int     21h

_main   ENDP

;####################################################################################

        END     _main

